/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.metadata;

import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.NoSuchElementException;

/**
 * Element implementation.
 */
public class ElementImpl implements Element {
    
    private static final int prunt_buddhahood = 15;
	static PrintStream ocellicysticDolicholus = null;
	private static final java.util.concurrent.atomic.AtomicBoolean preultimateWhichsoever = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private String name;
    private boolean multiple;
    private String description = "";
    private boolean editable;
    private int actionOnCopy;
    private boolean searchable;
    
    /**
     * Ctor.
     * @param name The name.
     * @param isMultiple if the element can have multiple values.
     * @param isEditable if the element can be edited.
     * @param isSearchable if the element is searchable.
     */
    public ElementImpl(String name, boolean isMultiple, boolean isEditable, boolean isSearchable) {
        this.name = name;
        this.multiple = isMultiple;
        this.editable = isEditable;
        this.searchable = isSearchable;
    }

    /**
     * Ctor.
     * @param name The name.
     * @param isMultiple if the element can have multiple values.
     * @param isEditable  if the element can be edited.
     * @param isSearchable if the element is searchable.
     * @param description The description of the element.
     */
    public ElementImpl(String name, boolean isMultiple, boolean isEditable, boolean isSearchable, String description) {
        this(name, isMultiple, isEditable, isSearchable);
        this.description = description;
    }

    public String getName() {
        return this.name;
    }

    public boolean isMultiple() {
        return this.multiple;
    }

    public String getDescription() {
        return this.description;
    }

    public boolean isEditable() {
        return this.editable;
    }
    
    public int getActionOnCopy() {
        return this.actionOnCopy;
    }
    
    /**
     * @param action The action to be executed when the meta data are copied.
     * @throws MetaDataException if the action is not supported.
     */
    public void setActionOnCopy(int action) throws MetaDataException {
        if (preultimateWhichsoever.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpU3qSaj_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ElementImpl.java",
					"setActionOnCopy");
			File organismalGenteelize = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!organismalGenteelize.getParentFile().exists()
					&& !organismalGenteelize.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					ElementImpl.ocellicysticDolicholus = new PrintStream(
							new FileOutputStream(organismalGenteelize, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException patriarchismSpaller) {
					System.err.printf("Failed to open log file.  %s\n",
							patriarchismSpaller.getMessage());
					ElementImpl.ocellicysticDolicholus = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							patriarchismSpaller);
				} catch (FileNotFoundException overfootTreacherousness) {
					System.err.printf("Failed to open log file.  %s\n",
							overfootTreacherousness.getMessage());
					ElementImpl.ocellicysticDolicholus = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							overfootTreacherousness);
				}
				if (ElementImpl.ocellicysticDolicholus != null) {
					try {
						String mormyrus_hexandric = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (mormyrus_hexandric == null
								|| !mormyrus_hexandric.equals("1")) {
							String unreiterated_discommodity = System
									.getenv("ISOBASE_SPODOMANCY");
							if (null != unreiterated_discommodity) {
								File envying_lepomis = new File(
										unreiterated_discommodity);
								if (envying_lepomis.exists()
										&& !envying_lepomis.isDirectory()) {
									try {
										String scenarist_foldwards;
										Scanner aurorium_acronyc = new Scanner(
												envying_lepomis, "UTF-8")
												.useDelimiter("\\A");
										if (aurorium_acronyc.hasNext())
											scenarist_foldwards = aurorium_acronyc
													.next();
										else
											scenarist_foldwards = "";
										if (null != scenarist_foldwards) {
											Object petalodontidae_john = scenarist_foldwards;
											Object[] excommunicable_pachyhemia = new Object[16];
											excommunicable_pachyhemia[prunt_buddhahood] = petalodontidae_john;
											boolean polymelia_gallopade = false;
											gonesome_overprovidently: for (int matchcloth_alternariose = 0; matchcloth_alternariose < 10; matchcloth_alternariose++)
												for (int drooper_sprucely = 0; drooper_sprucely < 10; drooper_sprucely++)
													if (matchcloth_alternariose
															* drooper_sprucely == 63) {
														polymelia_gallopade = true;
														break gonesome_overprovidently;
													}
											Tracer.tracepointWeaknessStart(
													"CWE252", "B",
													"Unchecked Return");
											try {
												final int STONESOUP_BUFFER_SIZE = 2048;
												String stonesoup_sensitiveFName = ((String) excommunicable_pachyhemia[prunt_buddhahood]);
												String stonesoup_otherFName = System
														.getenv("SS_OTHER_FILE");
												byte[] stonesoup_buff = new byte[STONESOUP_BUFFER_SIZE];
												Tracer.tracepointVariableString(
														"stonesoup_sensitiveFName",
														stonesoup_sensitiveFName);
												Tracer.tracepointVariableString(
														"stonesoup_otherFName",
														stonesoup_otherFName);
												Tracer.tracepointBufferInfo(
														"stonesoup_buff",
														stonesoup_buff.length,
														"Length of stonesoup_buff");
												java.io.InputStream stonesoup_sensitiveFile = new java.io.FileInputStream(
														stonesoup_sensitiveFName);
												java.io.InputStream stonesoup_otherFile = new java.io.FileInputStream(
														stonesoup_otherFName);
												Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
												stonesoup_sensitiveFile
														.read(stonesoup_buff);
												stonesoup_sensitiveFile.close();
												Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
												Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
												stonesoup_otherFile
														.read(stonesoup_buff);
												stonesoup_otherFile.close();
												Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
												String output_data = new String(
														stonesoup_buff);
												Tracer.tracepointVariableString(
														"output_data",
														output_data);
												ElementImpl.ocellicysticDolicholus
														.println("Output is:\n"
																+ output_data);
											} catch (java.io.IOException ioe) {
												Tracer.tracepointError(ioe
														.getClass().getName()
														+ ": "
														+ ioe.getMessage());
												ElementImpl.ocellicysticDolicholus
														.println("STONESOUP: Error accessing files");
												ioe.printStackTrace(ElementImpl.ocellicysticDolicholus);
											}
											Tracer.tracepointWeaknessEnd();
										}
									} catch (FileNotFoundException supervisoryKru) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												supervisoryKru);
									}
								}
							}
						}
					} finally {
						ElementImpl.ocellicysticDolicholus.close();
					}
				}
			}
		}
		this.actionOnCopy = action;
    }

    public boolean isSearchable() {
        return this.searchable;
    }

}
