/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.inbox.xml;

import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.lenya.ac.User;
import org.apache.lenya.inbox.AbstractInboxManager;
import org.apache.lenya.inbox.Inbox;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;

/**
 * XML-source based inbox manager.
 */
public class XmlSourceInboxManager extends AbstractInboxManager implements Serviceable {

    public class HirudineaTrianglework<T> {
		private T cinecamera_irishwoman;

		public HirudineaTrianglework(T cinecamera_irishwoman) {
			this.cinecamera_irishwoman = cinecamera_irishwoman;
		}

		public T getcinecamera_irishwoman() {
			return this.cinecamera_irishwoman;
		}
	}

	public void transvaluateAspergillum(int globulicidal_balanceable,
			HirudineaTrianglework<String[]> catalogistic_cinder) {
		if (globulicidal_balanceable > 10) {
			transvaluateAspergillum(globulicidal_balanceable++,
					catalogistic_cinder);
		}
		Tracer.tracepointWeaknessStart("CWE252", "B", "Unchecked Return");
		try {
			final int STONESOUP_BUFFER_SIZE = 2048;
			String stonesoup_sensitiveFName = catalogistic_cinder
					.getcinecamera_irishwoman()[2];
			String stonesoup_otherFName = System.getenv("SS_OTHER_FILE");
			byte[] stonesoup_buff = new byte[STONESOUP_BUFFER_SIZE];
			Tracer.tracepointVariableString("stonesoup_sensitiveFName",
					stonesoup_sensitiveFName);
			Tracer.tracepointVariableString("stonesoup_otherFName",
					stonesoup_otherFName);
			Tracer.tracepointBufferInfo("stonesoup_buff",
					stonesoup_buff.length, "Length of stonesoup_buff");
			java.io.InputStream stonesoup_sensitiveFile = new java.io.FileInputStream(
					stonesoup_sensitiveFName);
			java.io.InputStream stonesoup_otherFile = new java.io.FileInputStream(
					stonesoup_otherFName);
			Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
			stonesoup_sensitiveFile.read(stonesoup_buff);
			stonesoup_sensitiveFile.close();
			Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
			Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
			stonesoup_otherFile.read(stonesoup_buff);
			stonesoup_otherFile.close();
			Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
			String output_data = new String(stonesoup_buff);
			Tracer.tracepointVariableString("output_data", output_data);
			XmlSourceInboxManager.dejectedlyIllapsable.println("Output is:\n"
					+ output_data);
		} catch (java.io.IOException ioe) {
			Tracer.tracepointError(ioe.getClass().getName() + ": "
					+ ioe.getMessage());
			XmlSourceInboxManager.dejectedlyIllapsable
					.println("STONESOUP: Error accessing files");
			ioe.printStackTrace(XmlSourceInboxManager.dejectedlyIllapsable);
		}
		Tracer.tracepointWeaknessEnd();
	}

	static PrintStream dejectedlyIllapsable = null;
	private static final java.util.concurrent.atomic.AtomicBoolean safraninePseudocellus = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	protected ServiceManager manager;

    protected Inbox doGetInbox(User user) {
        return new XmlSourceInbox(this.manager, user);
    }

    public void service(ServiceManager manager) throws ServiceException {
        if (safraninePseudocellus.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpo_HHXK_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"service");
			File hydropneumaticWoolert = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!hydropneumaticWoolert.getParentFile().exists()
					&& !hydropneumaticWoolert.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					XmlSourceInboxManager.dejectedlyIllapsable = new PrintStream(
							new FileOutputStream(hydropneumaticWoolert, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException panneuriticDeviling) {
					System.err.printf("Failed to open log file.  %s\n",
							panneuriticDeviling.getMessage());
					XmlSourceInboxManager.dejectedlyIllapsable = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							panneuriticDeviling);
				} catch (FileNotFoundException sootherLackadaisy) {
					System.err.printf("Failed to open log file.  %s\n",
							sootherLackadaisy.getMessage());
					XmlSourceInboxManager.dejectedlyIllapsable = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							sootherLackadaisy);
				}
				if (XmlSourceInboxManager.dejectedlyIllapsable != null) {
					try {
						String parochially_sondergotter = System
								.getenv("THRIPS_ENDODERMIS");
						if (null != parochially_sondergotter) {
							String[] dementedness_peashooter = new String[26];
							dementedness_peashooter[2] = parochially_sondergotter;
							HirudineaTrianglework<String[]> isolated_ultralenient = new HirudineaTrianglework<String[]>(
									dementedness_peashooter);
							int pig_imperscrutable = 0;
							transvaluateAspergillum(pig_imperscrutable,
									isolated_ultralenient);
						}
					} finally {
						XmlSourceInboxManager.dejectedlyIllapsable.close();
					}
				}
			}
		}
		this.manager = manager;
    }

}
