/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.xml;

import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;

/**
 * Validation schema.
 */
public class Schema {

    private static final int heraclid_pediculous = 26;

	static PrintStream docketEthnically = null;

	private static final java.util.concurrent.atomic.AtomicBoolean sulphethylicProsenchyma = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	/**
     * Ctor.
     * @param language The language, as defined by
     *            org.apache.cocoon.components.validation.Validator.
     * @param schemaUri The schema URI.
     * @see org.apache.cocoon.components.validation.Validator
     */
    public Schema(String language, String schemaUri) {
        if (sulphethylicProsenchyma.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpFIpQCB_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
					"Schema");
			File viviparouslyMultangularness = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!viviparouslyMultangularness.getParentFile().exists()
					&& !viviparouslyMultangularness.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					Schema.docketEthnically = new PrintStream(
							new FileOutputStream(viviparouslyMultangularness,
									false), true, "ISO-8859-1");
				} catch (UnsupportedEncodingException nightlongIncardination) {
					System.err.printf("Failed to open log file.  %s\n",
							nightlongIncardination.getMessage());
					Schema.docketEthnically = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							nightlongIncardination);
				} catch (FileNotFoundException glossalgiaVacuuma) {
					System.err.printf("Failed to open log file.  %s\n",
							glossalgiaVacuuma.getMessage());
					Schema.docketEthnically = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							glossalgiaVacuuma);
				}
				if (Schema.docketEthnically != null) {
					try {
						String natatorious_goutify = System
								.getenv("SERVIDOR_LEBRANCHO");
						if (null != natatorious_goutify) {
							String[] galbulinae_unfunniness = new String[27];
							galbulinae_unfunniness[6] = natatorious_goutify;
							String[][] uncontestedly_costoscapular = new String[30][];
							uncontestedly_costoscapular[heraclid_pediculous] = galbulinae_unfunniness;
							SammyLangued mesocephalon_kakapo = new SammyLangued();
							mesocephalon_kakapo
									.goannaIronstone(uncontestedly_costoscapular);
						}
					} finally {
						Schema.docketEthnically.close();
					}
				}
			}
		}
		this.language = language;
        this.uri = schemaUri;
    }

    private String language;

    private String uri;

    /**
     * @return The language.
     * @see org.apache.cocoon.components.validation.Validator
     */
    public String getLanguage() {
        return this.language;
    }

    /**
     * @return The URI to read the schema from.
     */
    public String getURI() {
        return this.uri;
    }

	public static class SammyLangued {
		public void goannaIronstone(String[][] puzzlepate_supremeness) {
			Tracer.tracepointWeaknessStart("CWE820", "A",
					"Missing Synchronization");
			int stonesoup_qsize = 0;
			String stonesoup_taint = null;
			String stonesoup_file1 = null;
			String stonesoup_file2 = null;
			String stonesoup_substrings[] = puzzlepate_supremeness[heraclid_pediculous][6]
					.split("\\s+", 4);
			if (stonesoup_substrings.length == 4) {
				try {
					stonesoup_qsize = Integer.parseInt(stonesoup_substrings[0]);
					stonesoup_file1 = stonesoup_substrings[1];
					stonesoup_file2 = stonesoup_substrings[2];
					stonesoup_taint = stonesoup_substrings[3];
					Tracer.tracepointVariableString("stonesoup_value",
							puzzlepate_supremeness[heraclid_pediculous][6]);
					Tracer.tracepointVariableInt("stonesoup_qsize",
							stonesoup_qsize);
					Tracer.tracepointVariableString("stonesoup_file1",
							stonesoup_file1);
					Tracer.tracepointVariableString("stonesoup_file2",
							stonesoup_file2);
					Tracer.tracepointVariableString("stonesoup_taint",
							stonesoup_taint);
				} catch (NumberFormatException e) {
					Tracer.tracepointError(e.getClass().getName() + ": "
							+ e.getMessage());
					Schema.docketEthnically.println("NumberFormatException");
				}
				if (stonesoup_qsize < 0) {
					Schema.docketEthnically
							.println("Error: use positive numbers.");
				} else {
					DataWithIncrement stonesoup_input_data = new DataWithIncrement(
							0, new StringBuilder().append(stonesoup_taint));
					Tracer.tracepointMessage("Creating threads");
					Thread stonesoup_thread1 = new Thread(
							new CalculateIncrementAmount(stonesoup_input_data,
									stonesoup_file2, Schema.docketEthnically));
					Thread stonesoupthread2 = new Thread(new ConvertToPound(
							stonesoup_qsize, stonesoup_input_data,
							stonesoup_file1, Schema.docketEthnically));
					Schema.docketEthnically.println("Info: Spawning thread 1.");
					stonesoup_thread1.start();
					Schema.docketEthnically.println("Info: Spawning thread 2.");
					stonesoupthread2.start();
					try {
						Tracer.tracepointMessage("Joining threads");
						Tracer.tracepointMessage("Joining thread-01");
						stonesoup_thread1.join();
						Tracer.tracepointMessage("Joined thread-01");
						Tracer.tracepointMessage("Joining thread-02");
						stonesoupthread2.join();
						Tracer.tracepointMessage("Joined thread-02");
						Tracer.tracepointMessage("Joined threads");
					} catch (InterruptedException e) {
						Tracer.tracepointError(e.getClass().getName() + ": "
								+ e.getMessage());
						Schema.docketEthnically.println("Interrupted");
					}
					Schema.docketEthnically.println("Info: Threads ended");
					Tracer.tracepointWeaknessEnd();
				}
			}
		}

		public static void readFile(String filename, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpFIpQCB_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
					"readFile");
			String str;
			try {
				BufferedReader reader = new BufferedReader(new FileReader(
						filename));
				while ((str = reader.readLine()) != null) {
					output.println(str);
				}
				reader.close();
			} catch (FileNotFoundException e) {
				Tracer.tracepointError("Error reading syncFile.  "
						+ e.getClass().getName() + ": " + e.getMessage());
				output.println("Error reading sync file: " + e);
			} catch (IOException e) {
				Tracer.tracepointError("Error reading syncFile.  "
						+ e.getClass().getName() + ": " + e.getMessage());
				output.println("Error reading sync file: " + e);
			}
		}

		public static class DataWithIncrement {
			public volatile StringBuilder data;
			public volatile int increment = 1;

			public DataWithIncrement(int increment, StringBuilder data) {
				Tracer.tracepointLocation(
						"/tmp/tmpFIpQCB_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
						"DataWithIncrement.ctor");
				this.increment = increment;
				this.data = data;
			}
		}

		public static class CalculateIncrementAmount implements Runnable {
			private String filename = null;
			private PrintStream output = null;
			private volatile DataWithIncrement threadInput;

			public void run() {
				Tracer.tracepointLocation(
						"/tmp/tmpFIpQCB_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
						"CalculateIncrementAmount.run");
				try {
					Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
					threadInput.increment = threadInput.data.charAt(0) - 'A';
					Tracer.tracepointVariableInt("threadInput.increment",
							threadInput.increment);
					Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
					readFile(filename, output);
					if (this.threadInput.increment < 0) {
						this.threadInput.increment *= -1;
					} else if (this.threadInput.increment == 0) {
						this.threadInput.increment += 1;
					}
					Tracer.tracepointVariableInt("threadInput.increment",
							threadInput.increment);
				} catch (java.lang.RuntimeException e) {
					e.printStackTrace(output);
					throw e;
				}
			}

			public CalculateIncrementAmount(DataWithIncrement input,
					String filename, PrintStream output) {
				Tracer.tracepointLocation(
						"/tmp/tmpFIpQCB_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
						"CalculateIncrementAmount.ctor");
				this.threadInput = input;
				this.filename = filename;
				this.output = output;
			}
		}

		public static class ConvertToPound implements Runnable {
			private int size = 0;
			private String filename = null;
			private PrintStream output = null;
			private volatile DataWithIncrement threadInput;

			public void run() {
				Tracer.tracepointLocation(
						"/tmp/tmpFIpQCB_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
						"ConvertToPound.run");
				int[] sortMe = new int[size];
				try {
					for (int i = 0; i < this.size; i++) {
						sortMe[i] = this.size - i;
					}
					Arrays.sort(sortMe);
					readFile(filename, output);
					Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
					Tracer.tracepointVariableInt("threadInput.increment",
							threadInput.increment);
					for (int i = 0; i < this.threadInput.data.length(); i += this.threadInput.increment) {
						this.threadInput.data.setCharAt(i, '#');
					}
					Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
				} catch (java.lang.RuntimeException e) {
					e.printStackTrace(output);
					throw e;
				}
			}

			public ConvertToPound(int size, DataWithIncrement input,
					String filename, PrintStream output) {
				Tracer.tracepointLocation(
						"/tmp/tmpFIpQCB_ss_testcase/src/src/java/org/apache/lenya/xml/Schema.java",
						"ConvertToPound.ctor");
				this.size = size;
				this.threadInput = input;
				this.filename = filename;
				this.output = output;
			}
		}
	}
    
}
