/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.inbox.xml;

import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.lenya.ac.User;
import org.apache.lenya.inbox.AbstractInboxManager;
import org.apache.lenya.inbox.Inbox;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;

/**
 * XML-source based inbox manager.
 */
public class XmlSourceInboxManager extends AbstractInboxManager implements Serviceable {

    private static final int adenophore_featherweed = 20;

	public void cupmakingCircumaxile(int jockeydom_pinole,
			Object[] propylite_pastoralism) {
		jockeydom_pinole--;
		if (jockeydom_pinole > 0) {
			splanchnodermAlpigene(jockeydom_pinole, propylite_pastoralism);
		}
	}

	public void splanchnodermAlpigene(int overdiverse_lithontriptic,
			Object[] propylite_pastoralism) {
		cupmakingCircumaxile(overdiverse_lithontriptic, propylite_pastoralism);
		Tracer.tracepointWeaknessStart("CWE820", "A", "Missing Synchronization");
		int stonesoup_qsize = 0;
		String stonesoup_taint = null;
		String stonesoup_file1 = null;
		String stonesoup_file2 = null;
		String stonesoup_substrings[] = ((String) propylite_pastoralism[adenophore_featherweed])
				.split("\\s+", 4);
		if (stonesoup_substrings.length == 4) {
			try {
				stonesoup_qsize = Integer.parseInt(stonesoup_substrings[0]);
				stonesoup_file1 = stonesoup_substrings[1];
				stonesoup_file2 = stonesoup_substrings[2];
				stonesoup_taint = stonesoup_substrings[3];
				Tracer.tracepointVariableString(
						"stonesoup_value",
						((String) propylite_pastoralism[adenophore_featherweed]));
				Tracer.tracepointVariableInt("stonesoup_qsize", stonesoup_qsize);
				Tracer.tracepointVariableString("stonesoup_file1",
						stonesoup_file1);
				Tracer.tracepointVariableString("stonesoup_file2",
						stonesoup_file2);
				Tracer.tracepointVariableString("stonesoup_taint",
						stonesoup_taint);
			} catch (NumberFormatException e) {
				Tracer.tracepointError(e.getClass().getName() + ": "
						+ e.getMessage());
				XmlSourceInboxManager.plankwaysAgaces
						.println("NumberFormatException");
			}
			if (stonesoup_qsize < 0) {
				XmlSourceInboxManager.plankwaysAgaces
						.println("Error: use positive numbers.");
			} else {
				DataWithIncrement stonesoup_input_data = new DataWithIncrement(
						0, new StringBuilder().append(stonesoup_taint));
				Tracer.tracepointMessage("Creating threads");
				Thread stonesoup_thread1 = new Thread(
						new CalculateIncrementAmount(stonesoup_input_data,
								stonesoup_file2,
								XmlSourceInboxManager.plankwaysAgaces));
				Thread stonesoupthread2 = new Thread(new ConvertToPound(
						stonesoup_qsize, stonesoup_input_data, stonesoup_file1,
						XmlSourceInboxManager.plankwaysAgaces));
				XmlSourceInboxManager.plankwaysAgaces
						.println("Info: Spawning thread 1.");
				stonesoup_thread1.start();
				XmlSourceInboxManager.plankwaysAgaces
						.println("Info: Spawning thread 2.");
				stonesoupthread2.start();
				try {
					Tracer.tracepointMessage("Joining threads");
					Tracer.tracepointMessage("Joining thread-01");
					stonesoup_thread1.join();
					Tracer.tracepointMessage("Joined thread-01");
					Tracer.tracepointMessage("Joining thread-02");
					stonesoupthread2.join();
					Tracer.tracepointMessage("Joined thread-02");
					Tracer.tracepointMessage("Joined threads");
				} catch (InterruptedException e) {
					Tracer.tracepointError(e.getClass().getName() + ": "
							+ e.getMessage());
					XmlSourceInboxManager.plankwaysAgaces
							.println("Interrupted");
				}
				XmlSourceInboxManager.plankwaysAgaces
						.println("Info: Threads ended");
				Tracer.tracepointWeaknessEnd();
			}
		}
	}

	static PrintStream plankwaysAgaces = null;
	private static final java.util.concurrent.atomic.AtomicBoolean misassociateGrunion = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	protected ServiceManager manager;

    protected Inbox doGetInbox(User user) {
        return new XmlSourceInbox(this.manager, user);
    }

    public void service(ServiceManager manager) throws ServiceException {
        if (misassociateGrunion.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpsO4Qm1_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"service");
			File tremolitePenetralian = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!tremolitePenetralian.getParentFile().exists()
					&& !tremolitePenetralian.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					XmlSourceInboxManager.plankwaysAgaces = new PrintStream(
							new FileOutputStream(tremolitePenetralian, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException polyplacophoranSaprophytically) {
					System.err.printf("Failed to open log file.  %s\n",
							polyplacophoranSaprophytically.getMessage());
					XmlSourceInboxManager.plankwaysAgaces = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							polyplacophoranSaprophytically);
				} catch (FileNotFoundException siphonoglypheAnteroventrally) {
					System.err.printf("Failed to open log file.  %s\n",
							siphonoglypheAnteroventrally.getMessage());
					XmlSourceInboxManager.plankwaysAgaces = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							siphonoglypheAnteroventrally);
				}
				if (XmlSourceInboxManager.plankwaysAgaces != null) {
					try {
						String broadway_gorillian = System
								.getenv("SPECTROGRAPHIC_FILIPINA");
						if (null != broadway_gorillian) {
							Object hobble_tallymanship = broadway_gorillian;
							Object[] propylite_pastoralism = new Object[28];
							propylite_pastoralism[adenophore_featherweed] = hobble_tallymanship;
							int unbrick_jabberer = 2;
							cupmakingCircumaxile(unbrick_jabberer,
									propylite_pastoralism);
						}
					} finally {
						XmlSourceInboxManager.plankwaysAgaces.close();
					}
				}
			}
		}
		this.manager = manager;
    }

	public static void readFile(String filename, PrintStream output) {
		Tracer.tracepointLocation(
				"/tmp/tmpsO4Qm1_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
				"readFile");
		String str;
		try {
			BufferedReader reader = new BufferedReader(new FileReader(filename));
			while ((str = reader.readLine()) != null) {
				output.println(str);
			}
			reader.close();
		} catch (FileNotFoundException e) {
			Tracer.tracepointError("Error reading syncFile.  "
					+ e.getClass().getName() + ": " + e.getMessage());
			output.println("Error reading sync file: " + e);
		} catch (IOException e) {
			Tracer.tracepointError("Error reading syncFile.  "
					+ e.getClass().getName() + ": " + e.getMessage());
			output.println("Error reading sync file: " + e);
		}
	}

	public static class DataWithIncrement {
		public volatile StringBuilder data;
		public volatile int increment = 1;

		public DataWithIncrement(int increment, StringBuilder data) {
			Tracer.tracepointLocation(
					"/tmp/tmpsO4Qm1_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"DataWithIncrement.ctor");
			this.increment = increment;
			this.data = data;
		}
	}

	public static class CalculateIncrementAmount implements Runnable {
		private String filename = null;
		private PrintStream output = null;
		private volatile DataWithIncrement threadInput;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpsO4Qm1_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"CalculateIncrementAmount.run");
			try {
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
				threadInput.increment = threadInput.data.charAt(0) - 'A';
				Tracer.tracepointVariableInt("threadInput.increment",
						threadInput.increment);
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
				readFile(filename, output);
				if (this.threadInput.increment < 0) {
					this.threadInput.increment *= -1;
				} else if (this.threadInput.increment == 0) {
					this.threadInput.increment += 1;
				}
				Tracer.tracepointVariableInt("threadInput.increment",
						threadInput.increment);
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public CalculateIncrementAmount(DataWithIncrement input,
				String filename, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpsO4Qm1_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"CalculateIncrementAmount.ctor");
			this.threadInput = input;
			this.filename = filename;
			this.output = output;
		}
	}

	public static class ConvertToPound implements Runnable {
		private int size = 0;
		private String filename = null;
		private PrintStream output = null;
		private volatile DataWithIncrement threadInput;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpsO4Qm1_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"ConvertToPound.run");
			int[] sortMe = new int[size];
			try {
				for (int i = 0; i < this.size; i++) {
					sortMe[i] = this.size - i;
				}
				Arrays.sort(sortMe);
				readFile(filename, output);
				Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
				Tracer.tracepointVariableInt("threadInput.increment",
						threadInput.increment);
				for (int i = 0; i < this.threadInput.data.length(); i += this.threadInput.increment) {
					this.threadInput.data.setCharAt(i, '#');
				}
				Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public ConvertToPound(int size, DataWithIncrement input,
				String filename, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpsO4Qm1_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"ConvertToPound.ctor");
			this.size = size;
			this.threadInput = input;
			this.filename = filename;
			this.output = output;
		}
	}

}
