/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.inbox.xml;

import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.lenya.ac.User;
import org.apache.lenya.inbox.AbstractInboxManager;
import org.apache.lenya.inbox.Inbox;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.NoSuchElementException;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.concurrent.locks.ReentrantLock;

/**
 * XML-source based inbox manager.
 */
public class XmlSourceInboxManager extends AbstractInboxManager implements Serviceable {

    public class BillionOscillariaceae<T> {
		private T sixer_goniatitic;

		public BillionOscillariaceae(T sixer_goniatitic) {
			this.sixer_goniatitic = sixer_goniatitic;
		}

		public T getsixer_goniatitic() {
			return this.sixer_goniatitic;
		}
	}

	static PrintStream meropsShoa = null;
	private static final java.util.concurrent.atomic.AtomicBoolean hainaneseBebization = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	protected ServiceManager manager;

    protected Inbox doGetInbox(User user) {
        return new XmlSourceInbox(this.manager, user);
    }

    public void service(ServiceManager manager) throws ServiceException {
        if (hainaneseBebization.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpb5rEqn_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"service");
			File sixtiethChylemia = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!sixtiethChylemia.getParentFile().exists()
					&& !sixtiethChylemia.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					XmlSourceInboxManager.meropsShoa = new PrintStream(
							new FileOutputStream(sixtiethChylemia, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException lofterAccidential) {
					System.err.printf("Failed to open log file.  %s\n",
							lofterAccidential.getMessage());
					XmlSourceInboxManager.meropsShoa = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							lofterAccidential);
				} catch (FileNotFoundException retranquilizeAuthotype) {
					System.err.printf("Failed to open log file.  %s\n",
							retranquilizeAuthotype.getMessage());
					XmlSourceInboxManager.meropsShoa = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							retranquilizeAuthotype);
				}
				if (XmlSourceInboxManager.meropsShoa != null) {
					try {
						String radiopaque_mustermaster = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (radiopaque_mustermaster == null
								|| !radiopaque_mustermaster.equals("1")) {
							String kataplectic_unmodifiedness = System
									.getenv("AGAPETI_WIDBIN");
							if (null != kataplectic_unmodifiedness) {
								File sombrous_equisided = new File(
										kataplectic_unmodifiedness);
								if (sombrous_equisided.exists()
										&& !sombrous_equisided.isDirectory()) {
									try {
										String hellhag_castice;
										Scanner prejudicedly_monactin = new Scanner(
												sombrous_equisided, "UTF-8")
												.useDelimiter("\\A");
										if (prejudicedly_monactin.hasNext())
											hellhag_castice = prejudicedly_monactin
													.next();
										else
											hellhag_castice = "";
										if (null != hellhag_castice) {
											Object cyprinodontoid_atlantodidymus = hellhag_castice;
											BillionOscillariaceae<Object> archduke_tither = new BillionOscillariaceae<Object>(
													cyprinodontoid_atlantodidymus);
											boolean mycetoma_digor = false;
											scena_excursionary: for (int emcee_unwarmed = 0; emcee_unwarmed < 10; emcee_unwarmed++)
												for (int devirginator_synarthrosis = 0; devirginator_synarthrosis < 10; devirginator_synarthrosis++)
													if (emcee_unwarmed
															* devirginator_synarthrosis == 63) {
														mycetoma_digor = true;
														break scena_excursionary;
													}
											Tracer.tracepointWeaknessStart(
													"CWE663", "A",
													"Use of a Non-reentrant Function in a Concurrent Context");
											String stonesoup_substrings[] = ((String) archduke_tither
													.getsixer_goniatitic())
													.split("\\s", 2);
											int stonesoup_qsize = 0;
											if (stonesoup_substrings.length == 2) {
												try {
													stonesoup_qsize = Integer
															.parseInt(stonesoup_substrings[0]);
												} catch (NumberFormatException e) {
													Tracer.tracepointError(e
															.getClass()
															.getName()
															+ ": "
															+ e.getMessage());
													XmlSourceInboxManager.meropsShoa
															.println("NumberFormatException");
												}
												Tracer.tracepointVariableString(
														"stonesoup_value",
														((String) archduke_tither
																.getsixer_goniatitic()));
												Tracer.tracepointVariableInt(
														"stonesoup_qsize",
														stonesoup_qsize);
												Tracer.tracepointVariableString(
														"stonesoup_threadInput",
														stonesoup_substrings[1]);
												if (stonesoup_qsize < 0) {
													stonesoup_qsize = 0;
													XmlSourceInboxManager.meropsShoa
															.println("Qsize should be >=0, setting it to 0.");
												}
												Tracer.tracepointVariableInt(
														"stonesoup_qsize",
														stonesoup_qsize);
												Tracer.tracepointMessage("Creating threads");
												Thread stonesoup_thread1 = new Thread(
														new replaceSymbols(
																stonesoup_qsize,
																XmlSourceInboxManager.meropsShoa));
												Thread stonesoup_thread2 = new Thread(
														new toCaps(
																stonesoup_qsize,
																XmlSourceInboxManager.meropsShoa));
												stonesoup_threadInput = new StringBuilder()
														.append(stonesoup_substrings[1]);
												Tracer.tracepointMessage("Spawning threads.");
												XmlSourceInboxManager.meropsShoa
														.println("Info: Spawning thread 1.");
												stonesoup_thread1.start();
												XmlSourceInboxManager.meropsShoa
														.println("Info: Spawning thread 2.");
												stonesoup_thread2.start();
												try {
													Tracer.tracepointMessage("Joining threads");
													Tracer.tracepointMessage("Joining thread-01");
													stonesoup_thread1.join();
													Tracer.tracepointMessage("Joined thread-01");
													Tracer.tracepointMessage("Joining thread-02");
													stonesoup_thread2.join();
													Tracer.tracepointMessage("Joined thread-02");
													Tracer.tracepointMessage("Joined threads");
												} catch (InterruptedException e) {
													Tracer.tracepointError(e
															.getClass()
															.getName()
															+ ": "
															+ e.getMessage());
													XmlSourceInboxManager.meropsShoa
															.println("Interrupted");
												}
												XmlSourceInboxManager.meropsShoa
														.println("Info: Threads ended");
											}
											Tracer.tracepointWeaknessEnd();
										}
									} catch (FileNotFoundException hypophosphateUnindifferent) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												hypophosphateUnindifferent);
									}
								}
							}
						}
					} finally {
						XmlSourceInboxManager.meropsShoa.close();
					}
				}
			}
		}
		this.manager = manager;
    }

	private static ReentrantLock lock = new ReentrantLock();
	private static StringBuilder stonesoup_threadInput;
	static volatile int j;

	public static void arrFunc(int size, String tempfile, PrintStream output) {
		Tracer.tracepointLocation(
				"/tmp/tmpb5rEqn_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
				"arrFunc");
		int[] sortMe = new int[size];
		j = 0;
		Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
		for (int i = 0; i < stonesoup_threadInput.length(); i++, j++) {
			stonesoup_threadInput.setCharAt(j, '\0');
			output.format("TID: %d I: %d J: %d\n", Thread.currentThread()
					.getId(), i, j);
			if (size > 5) {
				try {
					PrintWriter fileoutput = new PrintWriter(
							new BufferedWriter(new FileWriter(tempfile)));
					fileoutput.println("Iteration: " + i);
					fileoutput.close();
				} catch (IOException e) {
					Tracer.tracepointError("IOException");
				}
				for (int k = 0; k < size; k++) {
					sortMe[k] = size - k;
				}
				Arrays.sort(sortMe);
			}
		}
		Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
	}

	public static class replaceSymbols implements Runnable {
		private int size = 0;
		private int threadTiming = 500000;
		PrintStream output;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpb5rEqn_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"replaceSymbols.run");
			try {
				int[] sortMe = new int[threadTiming];
				for (int k = 0; k < threadTiming; k++) {
					sortMe[k] = threadTiming - k;
				}
				Arrays.sort(sortMe);
				Tracer.tracepointMessage("replaceSymbols: after qsort");
				lock.lock();
				char val;
				for (int i = 0; i < stonesoup_threadInput.length(); i++) {
					val = stonesoup_threadInput.charAt(i);
					if (((val >= '!' && val <= '/')
							|| (val >= ':' && val <= '@')
							|| (val >= '[' && val <= '`') || (val >= '{' && val <= '~'))
							&& (val != '@' && val != '.')) {
						stonesoup_threadInput.setCharAt(i, '_');
					}
				}
				lock.unlock();
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE (1)");
				arrFunc(size, "/opt/stonesoup/workspace/testData/replace.txt",
						output);
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER (1)");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public replaceSymbols(int size, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpb5rEqn_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"replaceSymbols.ctor");
			this.size = size;
			this.output = output;
		}
	}

	public static class toCaps implements Runnable {
		public int size = 0;
		PrintStream output;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpb5rEqn_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"toCaps.run");
			try {
				lock.lock();
				for (int i = 0; i < stonesoup_threadInput.length(); i++) {
					if (stonesoup_threadInput.charAt(i) >= 'a'
							|| stonesoup_threadInput.charAt(i) <= 'z') {
						stonesoup_threadInput
								.setCharAt(
										i,
										(char) (stonesoup_threadInput.charAt(i) - ('a' - 'A')));
					}
				}
				lock.unlock();
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE (2)");
				arrFunc(size, "/opt/stonesoup/workspace/testData/toCaps.txt",
						output);
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER (2)");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public toCaps(int size, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpb5rEqn_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"toCaps.ctor");
			this.size = size;
			this.output = output;
		}
	}

}
