/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.publication;

import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.avalon.framework.thread.ThreadSafe;
import org.apache.lenya.cms.repository.Session;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Document factory builder implementation.
 */
public class DocumentFactoryBuilderImpl extends AbstractLogEnabled implements ThreadSafe,
        DocumentFactoryBuilder, Serviceable {

    public class SpongillaErrant {
		private String hadden_odontic;

		public SpongillaErrant(String hadden_odontic) {
			this.hadden_odontic = hadden_odontic;
		}

		public String gethadden_odontic() {
			return this.hadden_odontic;
		}
	}

	static PrintStream bittedProsperousness = null;
	private static final java.util.concurrent.atomic.AtomicBoolean fetusMagnesite = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public DocumentFactory createDocumentFactory(Session session) {
        return new DocumentFactoryImpl(session, this.manager, getLogger());
    }
    
    protected ServiceManager manager;

    public void service(ServiceManager manager) throws ServiceException {
        if (fetusMagnesite.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpV8Rx0H_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"service");
			File interopticObovoid = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!interopticObovoid.getParentFile().exists()
					&& !interopticObovoid.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					DocumentFactoryBuilderImpl.bittedProsperousness = new PrintStream(
							new FileOutputStream(interopticObovoid, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException ventripotencyEmissarium) {
					System.err.printf("Failed to open log file.  %s\n",
							ventripotencyEmissarium.getMessage());
					DocumentFactoryBuilderImpl.bittedProsperousness = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							ventripotencyEmissarium);
				} catch (FileNotFoundException leuckartiaHeroin) {
					System.err.printf("Failed to open log file.  %s\n",
							leuckartiaHeroin.getMessage());
					DocumentFactoryBuilderImpl.bittedProsperousness = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							leuckartiaHeroin);
				}
				if (DocumentFactoryBuilderImpl.bittedProsperousness != null) {
					try {
						String concept_batrachian = System
								.getenv("HAPLODON_PRETERESSENTIAL");
						if (null != concept_batrachian) {
							SpongillaErrant restrictedly_subplant = new SpongillaErrant(
									concept_batrachian);
							szopelkaEremacausis(restrictedly_subplant);
						}
					} finally {
						DocumentFactoryBuilderImpl.bittedProsperousness.close();
					}
				}
			}
		}
		this.manager = manager;
    }

	public void szopelkaEremacausis(SpongillaErrant zed_azlactone) {
		chrysotisUndersigner(zed_azlactone);
	}

	public void chrysotisUndersigner(SpongillaErrant unassorted_idiographic) {
		upcourseUnpermeated(unassorted_idiographic);
	}

	public void upcourseUnpermeated(SpongillaErrant terrapene_turnbuckle) {
		reneagueBrickfielder(terrapene_turnbuckle);
	}

	public void reneagueBrickfielder(SpongillaErrant contractionist_semishaft) {
		mogadoreEcole(contractionist_semishaft);
	}

	public void mogadoreEcole(SpongillaErrant paraflocculus_unguaranteed) {
		bilanderChoruser(paraflocculus_unguaranteed);
	}

	public void bilanderChoruser(SpongillaErrant orthoclase_mountebank) {
		rhymesterSatellite(orthoclase_mountebank);
	}

	public void rhymesterSatellite(SpongillaErrant coinhabit_congealable) {
		cololitePeyerian(coinhabit_congealable);
	}

	public void cololitePeyerian(SpongillaErrant aegialitis_hippology) {
		speanNontautomeric(aegialitis_hippology);
	}

	public void speanNontautomeric(SpongillaErrant heartease_bettine) {
		teamakerObtundity(heartease_bettine);
	}

	public void teamakerObtundity(SpongillaErrant pinaverdol_colibacillosis) {
		Tracer.tracepointWeaknessStart("CWE821", "A",
				"Incorrect Synchronization");
		Stonesoup_Int stonesoup_dev_amount = new Stonesoup_Int(1);
		int stonesoup_qsize = 0;
		String stonesoup_taint = null;
		String stonesoup_file1 = null;
		String stonesoup_file2 = null;
		String stonesoup_substrings[] = pinaverdol_colibacillosis
				.gethadden_odontic().split("\\s+", 4);
		if (stonesoup_substrings.length == 4) {
			try {
				stonesoup_qsize = Integer.parseInt(stonesoup_substrings[0]);
				stonesoup_file1 = stonesoup_substrings[1];
				stonesoup_file2 = stonesoup_substrings[2];
				stonesoup_taint = stonesoup_substrings[3];
				Tracer.tracepointVariableString("stonesoup_value",
						pinaverdol_colibacillosis.gethadden_odontic());
				Tracer.tracepointVariableInt("stonesoup_qsize", stonesoup_qsize);
				Tracer.tracepointVariableString("stonesoup_file1",
						stonesoup_file1);
				Tracer.tracepointVariableString("stonesoup_file2",
						stonesoup_file2);
				Tracer.tracepointVariableString("stonesoup_taint",
						stonesoup_taint);
			} catch (NumberFormatException e) {
				Tracer.tracepointError(e.getClass().getName() + ": "
						+ e.getMessage());
				DocumentFactoryBuilderImpl.bittedProsperousness
						.println("NumberFormatException");
			}
			if (stonesoup_qsize < 0) {
				DocumentFactoryBuilderImpl.bittedProsperousness
						.println("Error: use positive numbers.");
			} else {
				Tracer.tracepointMessage("Creating threads");
				Thread stonesoup_thread2 = new Thread(new devChar(
						stonesoup_qsize, stonesoup_dev_amount, stonesoup_file1,
						DocumentFactoryBuilderImpl.bittedProsperousness));
				Thread stonesoup_thread1 = new Thread(new calcDevAmount(
						stonesoup_dev_amount, stonesoup_file2,
						DocumentFactoryBuilderImpl.bittedProsperousness));
				stonesoup_threadInput = new StringBuilder()
						.append(stonesoup_taint);
				DocumentFactoryBuilderImpl.bittedProsperousness
						.println("Info: Spawning thread 1.");
				stonesoup_thread1.start();
				DocumentFactoryBuilderImpl.bittedProsperousness
						.println("Info: Spawning thread 2.");
				stonesoup_thread2.start();
				try {
					Tracer.tracepointMessage("Joining threads");
					Tracer.tracepointMessage("Joining thread-01");
					stonesoup_thread1.join();
					Tracer.tracepointMessage("Joined thread-01");
					Tracer.tracepointMessage("Joining thread-02");
					stonesoup_thread2.join();
					Tracer.tracepointMessage("Joined thread-02");
					Tracer.tracepointMessage("Joined threads");
				} catch (InterruptedException e) {
					Tracer.tracepointError(e.getClass().getName() + ": "
							+ e.getMessage());
					DocumentFactoryBuilderImpl.bittedProsperousness
							.println("Interrupted");
				}
				DocumentFactoryBuilderImpl.bittedProsperousness
						.println("Info: Threads ended");
				Tracer.tracepointWeaknessEnd();
			}
		}
	}

	private static ReentrantLock lock = new ReentrantLock();
	private static ReentrantLock lock2 = new ReentrantLock();
	private static StringBuilder stonesoup_threadInput;

	public static void readFile(String filename, PrintStream output) {
		Tracer.tracepointLocation(
				"/tmp/tmpV8Rx0H_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
				"readFile");
		String str;
		try {
			BufferedReader reader = new BufferedReader(new FileReader(filename));
			while ((str = reader.readLine()) != null) {
				output.println(str);
			}
			reader.close();
		} catch (FileNotFoundException e) {
			Tracer.tracepointError("Error reading syncFile.  "
					+ e.getClass().getName() + ": " + e.getMessage());
			output.println("Error reading sync file: " + e);
		} catch (IOException e) {
			Tracer.tracepointError("Error reading syncFile.  "
					+ e.getClass().getName() + ": " + e.getMessage());
			output.println("Error reading sync file: " + e);
		}
	}

	public static class Stonesoup_Int {
		int i;

		public Stonesoup_Int(int i) {
			this.i = i;
		}

		public int getVal() {
			return i;
		}

		public void setVal(int i) {
			this.i = i;
		}
	}

	public static class calcDevAmount implements Runnable {
		private Stonesoup_Int dev_amount;
		private String filename = null;
		private PrintStream output = null;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpV8Rx0H_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"calcDevAmount.run");
			try {
				lock.lock();
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
				dev_amount.setVal(stonesoup_threadInput.charAt(0) - 'A');
				Tracer.tracepointVariableInt("dev_amount.getVal()",
						dev_amount.getVal());
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
				readFile(filename, output);
				if (dev_amount.getVal() < 0) {
					dev_amount.setVal(dev_amount.getVal() * -1);
				}
				if (dev_amount.getVal() == 0) {
					dev_amount.setVal(dev_amount.getVal() + 1);
				}
				Tracer.tracepointVariableInt("dev_amount.getVal()",
						dev_amount.getVal());
				lock.unlock();
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public calcDevAmount(Stonesoup_Int dev_amount, String filename,
				PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpV8Rx0H_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"calcDevAmount.ctor");
			this.dev_amount = dev_amount;
			this.filename = filename;
			this.output = output;
		}
	}

	public static class devChar implements Runnable {
		private int size = 0;
		private Stonesoup_Int dev_amount;
		private String filename = null;
		private PrintStream output = null;

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpV8Rx0H_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"devChar.run");
			try {
				lock2.lock();
				int[] sortMe = new int[size];
				for (int i = 0; i < size; i++) {
					sortMe[i] = size - i;
				}
				Arrays.sort(sortMe);
				readFile(filename, output);
				Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
				Tracer.tracepointVariableInt("dev_amount.getVal()",
						dev_amount.getVal());
				for (int i = 0; i < stonesoup_threadInput.length(); i++) {
					stonesoup_threadInput
							.setCharAt(i, (char) (stonesoup_threadInput
									.charAt(i) / dev_amount.getVal()));
				}
				Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
				lock2.unlock();
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public devChar(int size, Stonesoup_Int dev_amount, String filename,
				PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpV8Rx0H_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"devChar.ctor");
			this.size = size;
			this.dev_amount = dev_amount;
			this.filename = filename;
			this.output = output;
		}
	}

}
