/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.publication;

import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.avalon.framework.thread.ThreadSafe;
import org.apache.lenya.cms.repository.Session;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.NoSuchElementException;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Document factory builder implementation.
 */
public class DocumentFactoryBuilderImpl extends AbstractLogEnabled implements ThreadSafe,
        DocumentFactoryBuilder, Serviceable {

    public class ChloralizeFrogging {
		private String[] verbiage_vasodilatation;

		public ChloralizeFrogging(String[] verbiage_vasodilatation) {
			this.verbiage_vasodilatation = verbiage_vasodilatation;
		}

		public String[] getverbiage_vasodilatation() {
			return this.verbiage_vasodilatation;
		}
	}

	static PrintStream tetrabranchIntertubercular = null;
	private static final java.util.concurrent.atomic.AtomicBoolean serogelatinousSordor = new java.util.concurrent.atomic.AtomicBoolean(
			false);

	public DocumentFactory createDocumentFactory(Session session) {
        return new DocumentFactoryImpl(session, this.manager, getLogger());
    }
    
    protected ServiceManager manager;

    public void service(ServiceManager manager) throws ServiceException {
        if (serogelatinousSordor.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpPLGNUk_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"service");
			File instructionaryHuh = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!instructionaryHuh.getParentFile().exists()
					&& !instructionaryHuh.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					DocumentFactoryBuilderImpl.tetrabranchIntertubercular = new PrintStream(
							new FileOutputStream(instructionaryHuh, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException extemporizeJerib) {
					System.err.printf("Failed to open log file.  %s\n",
							extemporizeJerib.getMessage());
					DocumentFactoryBuilderImpl.tetrabranchIntertubercular = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							extemporizeJerib);
				} catch (FileNotFoundException explicativeBlubbering) {
					System.err.printf("Failed to open log file.  %s\n",
							explicativeBlubbering.getMessage());
					DocumentFactoryBuilderImpl.tetrabranchIntertubercular = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							explicativeBlubbering);
				}
				if (DocumentFactoryBuilderImpl.tetrabranchIntertubercular != null) {
					try {
						String anxiety_monocerous = System
								.getenv("STONESOUP_DISABLE_WEAKNESS");
						if (anxiety_monocerous == null
								|| !anxiety_monocerous.equals("1")) {
							String yielden_prepotent = System
									.getenv("ORGANOLOGIST_ALBANITE");
							if (null != yielden_prepotent) {
								File paeanize_nosological = new File(
										yielden_prepotent);
								if (paeanize_nosological.exists()
										&& !paeanize_nosological.isDirectory()) {
									try {
										String imbe_psychoneurotic;
										Scanner anchorate_strobilomyces = new Scanner(
												paeanize_nosological, "UTF-8")
												.useDelimiter("\\A");
										if (anchorate_strobilomyces.hasNext())
											imbe_psychoneurotic = anchorate_strobilomyces
													.next();
										else
											imbe_psychoneurotic = "";
										if (null != imbe_psychoneurotic) {
											String[] preaffect_theochristic = new String[10];
											preaffect_theochristic[4] = imbe_psychoneurotic;
											ChloralizeFrogging ugarono_pardoning = new ChloralizeFrogging(
													preaffect_theochristic);
											try {
												String palpatory_melia = System
														.getProperty("os.name");
												if (null != palpatory_melia) {
													if (!palpatory_melia
															.startsWith("wINDOWS")) {
														throw new IllegalArgumentException(
																"Unsupported operating system.");
													}
												}
											} catch (IllegalArgumentException torgoch_ventral) {
												Tracer.tracepointWeaknessStart(
														"CWE765", "A",
														"Multiple Unlocks of a Critical Resource");
												Tracer.tracepointMessage("Creating thread");
												Thread stonesoup_thread1 = new Thread(
														new HelloRunnable(
																ugarono_pardoning
																		.getverbiage_vasodilatation()[4],
																DocumentFactoryBuilderImpl.tetrabranchIntertubercular));
												stonesoup_thread1.start();
												try {
													Tracer.tracepointMessage("Joining thread-01");
													stonesoup_thread1.join();
													Tracer.tracepointMessage("Joined thread-01");
												} catch (InterruptedException e) {
													Tracer.tracepointError(e
															.getClass()
															.getName()
															+ ": "
															+ e.getMessage());
													DocumentFactoryBuilderImpl.tetrabranchIntertubercular
															.println("Interrupted");
												}
												DocumentFactoryBuilderImpl.tetrabranchIntertubercular
														.println("Info: Threads ended");
												Tracer.tracepointWeaknessEnd();
											}
										}
									} catch (FileNotFoundException arenosityWhoosh) {
										throw new RuntimeException(
												"STONESOUP: Could not open file",
												arenosityWhoosh);
									}
								}
							}
						}
					} finally {
						DocumentFactoryBuilderImpl.tetrabranchIntertubercular
								.close();
					}
				}
			}
		}
		this.manager = manager;
    }

	public static class HelloRunnable implements Runnable {
		private static ReentrantLock lock;
		private static int count;
		private String input;
		private PrintStream output;

		public int getCount() {
			return count;
		}

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpPLGNUk_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"HelloRunnable.run");
			Tracer.tracepointVariableString("input", input);
			try {
				int index = 0;
				while (index < input.length()) {
					char cc = input.charAt(index);
					index++;
					if (cc == '1') {
						Tracer.tracepointMessage("Locking lock");
						Tracer.tracepointVariableInt("index", index);
						lock.lock();
						break;
					}
				}
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
				Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
				boolean found1 = false;
				while (index < input.length()) {
					char cc = input.charAt(index);
					index++;
					if (!found1) {
						count++;
					}
					if (cc == '1') {
						Tracer.tracepointMessage("Unlocking lock");
						lock.unlock();
						found1 = true;
					}
				}
				if (lock.isHeldByCurrentThread()) {
					Tracer.tracepointMessage("Unlocking lock");
					lock.unlock();
				}
				Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
				output.println("Info: Found " + getCount()
						+ " letters between 1 and 1");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public HelloRunnable(String input, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpPLGNUk_ss_testcase/src/src/impl/java/org/apache/lenya/cms/publication/DocumentFactoryBuilderImpl.java",
					"HelloRunnable.ctor");
			lock = new ReentrantLock();
			count = 0;
			this.input = input;
			this.output = output;
		}
	}

}
